'!TITLE "Calibration of Camera feeder L"
#INCLUDE "dio_tab.h"
#INCLUDE "VAR_TAB.h"

PROGRAM Calibration_L

Takearm

I[Code.ready_L_223]=0
I[Calpoint_L_220]=0
I[Calposition_L_221] = 0
Set IO[Set_Tool_L_811]

'Step 1.1						Switch camera offline
Run get_reply_L
delay 500
PRINT #9,"SO0"
PRINTDBG "SO0"
Wait I[Code.ready_L_223]=1
Wait I[Calibcode_L_225]=6
I[Code.ready_L_223]=0
I[Calibcode_L_225]=0

'Step 1.2						Load calibration job
Run get_reply_L
delay 500
PRINT #9,"LFCalibration32-P.job"				 
PRINTDBG "LFCalibration32-P.job"
Wait I[Code.ready_L_223]=1
Wait I[Calibcode_L_225]=6
I[Code.ready_L_223]=0
I[Calibcode_L_225]=0

'Step 1.3						Switch camera online
Run get_reply_L
delay 500
PRINT #9,"SO1"				 
PRINTDBG "SO1"
Wait I[Code.ready_L_223]=1
Wait I[Calibcode_L_225]=6
I[Code.ready_L_223]=0
I[Calibcode_L_225]=0

*Step2:

'Step 2							Choose calibration point
Run get_reply_L
delay 500
IF I[Calpoint_L_220]=0 then
	PRINT #9,"SIM0180"				 
	PRINTDBG "SIM0180"
ELSEIF I[Calpoint_L_220]=1 then
	PRINT #9,"SIM0181"				 
	PRINTDBG "SIM0181"
ELSEIF I[Calpoint_L_220]=2 then
	PRINT #9,"SIM0182"				 
	PRINTDBG "SIM0182"
ELSEIF I[Calpoint_L_220]=3 then
	PRINT #9,"SIM0183"				 
	PRINTDBG "SIM0183"
ELSEIF I[Calpoint_L_220]=4 then
	PRINT #9,"SE2"				 
	PRINTDBG "SE2"
	Wait I[Code.ready_L_223]=1
	I[Calpoint_L_220]=0
	GOTO *step14  
ENDIF
Wait I[Code.ready_L_223]=1
Wait I[Calibcode_L_225]=6
I[Code.ready_L_223]=0
I[Calibcode_L_225]=0

'Step 3							Start camera 
Run get_reply_L
delay 500
PRINT #9,"SE1"				 
PRINTDBG "SE1"
Wait I[Code.ready_L_223]=1
Wait I[Calibcode_L_225]=6
I[Code.ready_L_223]=0
I[Calibcode_L_225]=0

*Step4:

'Step 4							Read task from cell L0 
Run Get_double_reply_L
delay 500
PRINT #9,"GVL000"				 
PRINTDBG "GVL000"
Wait I[Code.ready_L_223]=1
Wait I[Calibcode_L_225]=6
I[Code.ready_L_223]=0


'Step 5
IF I[Calposition_L_221] = 5 THEN		'If "5" NoPart
	I[Calpoint_L_220]=I[Calpoint_L_220]+1
	I[Calposition_L_221]=0
	GOTO *Step2
ELSE
	PRINTDBG "Part ready to pickup"
	I[Calibcode_L_225]=0
ENDIF

'Step 6							Acknowledge 
Run get_reply_L
delay 500
PRINT #9,"SIH0001"				 
PRINTDBG "SIH0001"
Wait I[Code.ready_L_223]=1
Wait I[Calibcode_L_225]=6
I[Code.ready_L_223]=0
I[Calibcode_L_225]=0


'Step 7
IF I[Calposition_L_221] = 0 THEN		'If 0-3 then Calib else CalibZur
	PRINTDBG "Calib 0 L"
ELSEIF I[Calposition_L_221] = 1 THEN
	PRINTDBG "Calib 1 L"
ELSEIF I[Calposition_L_221] = 2 THEN
	PRINTDBG "Calib 2 L"
ELSEIF I[Calposition_L_221] = 3 THEN
	PRINTDBG "Calib 3 L"
ELSEIF I[Calposition_L_221] = 4 THEN
	PRINTDBG "CalibZur L"
	GOTO *Step12
ENDIF

'Step 8
IF I[Cal_in_nest_L_227] = 0 THEN			'If 0 pick up from nest
	PRINTDBG "Pick up from nest"
	Changework 0
	Changetool 2
	Move p,@20 p[224],s=50
  	APPROACH  L, P[250] ,70,S= 50
  	Move L,@E P[250],s=25
  	SET IO[Set_Vacuum_L_812]
  	delay 200
	DEPART L,@1 70,S=50
	Move L,@20 p[224],s=50
	I[Cal_in_nest_L_227] = 1
ELSE 								'If 1 pick up from lastposition
	PRINTDBG "Pick up from last pos"
	Changework 2
	Changetool 2
  	APPROACH  P,P[255] ,70,S= 50
  	Move L,@E P[255],s=25
  	SET IO[Set_Vacuum_L_812]
  	delay 200
	DEPART L,@1 70,S=50
ENDIF

IF I[Calposition_L_221] = 0 THEN		'Move to 0-3 Calib position
	PRINTDBG "Move Calib 0 L"
	Changework 2
	Changetool 2
  	APPROACH  P,P[251]+(0,0,0,0,0,I[Calangel_L_222]) ,70,S= 50
  	Move L,@E P[251]+(0,0,0,0,0,I[Calangel_L_222]),s=25
  	Reset IO[Set_Vacuum_L_812]
  	delay 200

ELSEIF I[Calposition_L_221] = 1 THEN
	PRINTDBG "Move Calib 1 L"
	Changework 2
	Changetool 2
  	APPROACH  P,P[252]+(0,0,0,0,0,I[Calangel_L_222]) ,70,S= 50
  	Move L,@E P[252]+(0,0,0,0,0,I[Calangel_L_222]),s=25
  	Reset IO[Set_Vacuum_L_812]
  	delay 200

ELSEIF I[Calposition_L_221] = 2 THEN
	PRINTDBG "Move Calib 2 L"
	Changework 2
	Changetool 2
  	APPROACH  P,P[253]+(0,0,0,0,0,I[Calangel_L_222]) ,70,S= 50
  	Move L,@E P[253]+(0,0,0,0,0,I[Calangel_L_222]),s=25
  	Reset IO[Set_Vacuum_L_812]
  	delay 200

ELSEIF I[Calposition_L_221] = 3 THEN
	PRINTDBG "Move Calib 3 L"
	Changework 2
	Changetool 2
  	APPROACH  P,P[254]+(0,0,0,0,0,I[Calangel_L_222]) ,70,S= 50
  	Move L,@E P[254]+(0,0,0,0,0,I[Calangel_L_222]),s=25
  	Reset IO[Set_Vacuum_L_812]
  	delay 200

ENDIF	

P[Calib_Last_pos_L]=CURPOS

'Step 9
Run get_reply_L
delay 500
F[POS_X_L]=POSX(P[Calib_Last_pos_L])'*100
PRINT #9,"SFP000",F[POS_X_L]				 
PRINTDBG "SFP000",F[POS_X_L]
Wait I[Code.ready_L_223]=1
Wait I[Calibcode_L_225]=6
I[Code.ready_L_223]=0
I[Calibcode_L_225]=0

Run get_reply_L
delay 500
F[POS_Y_L]=POSY(P[Calib_Last_pos_L])'*100
PRINT #9,"SFQ000",F[POS_Y_L]				 
PRINTDBG "SFQ000",F[POS_Y_L]
Wait I[Code.ready_L_223]=1
Wait I[Calibcode_L_225]=6
I[Code.ready_L_223]=0
I[Calibcode_L_225]=0

'Step 10					Robot out of FOV
DEPART L,@0 70,S=50
changework 0
Changetool 2

Move P,@0 P[224],s=50

'Step 11							Acknowledge
Run get_reply_L
delay 500
PRINT #9,"SIH0000"				 
PRINTDBG "SIH0000"
Wait I[Code.ready_L_223]=1
Wait I[Calibcode_L_225]=6
I[Code.ready_L_223]=0
I[Calibcode_L_225]=0
Goto *step4 

*Step12:
'Step 12
PRINTDBG "Pick up from last pos and place in nest"
Changework 2
Changetool 2
APPROACH  P,P[255] ,70,S= 50
Move L,@E P[255],s=25
SET IO[Set_Vacuum_L_812]
delay 200
DEPART L,@1 70,S=50

changework 0
Changetool 2
Move p,@20 p[224],s=50
APPROACH  L,P[250] ,70,S= 50
Move L,@E P[250],s=25
Reset IO[Set_Vacuum_L_812]
delay 200
DEPART L,@1 70,S=50
Move L,@0 P[224],s=50
I[Cal_in_nest_L_227] = 0

'Step 13							Acknowledge
Run get_reply_L
delay 500
PRINT #9,"SIH0000"				 
PRINTDBG "SIH0000"
Wait I[Code.ready_L_223]=1
Wait I[Calibcode_L_225]=6
I[Code.ready_L_223]=0
I[Calibcode_L_225]=0
Goto *step4 

*Step14:
Kill Get_reply_L
Kill Get_double_reply_L
RESET IO[Set_Tool_L_811]

END
