'!TITLE "Calibration of Camera feeder R"
#INCLUDE "dio_tab.h"
#INCLUDE "VAR_TAB.h"

PROGRAM Calibration_R

Takearm

I[Code.ready_R_123]=0
I[Calpoint_R_120]=0
I[Calposition_R_121] = 0
Set IO[Set_Tool_L_811]

'Step 1.1						Switch camera offline
Run get_reply_R
delay 500
PRINT #8,"SO0"
PRINTDBG "SO0"
Wait I[Code.ready_R_123]=1
Wait I[Calibcode_R_125]=6
I[Code.ready_R_123]=0
I[Calibcode_R_125]=0

'Step 1.2						Load calibration job
Run get_reply_R
delay 500
PRINT #8,"LFCalibration32-P.job"				 
PRINTDBG "LFCalibration32-P.job"
Wait I[Code.ready_R_123]=1
Wait I[Calibcode_R_125]=6
I[Code.ready_R_123]=0
I[Calibcode_R_125]=0

'Step 1.3						Switch camera online
Run get_reply_R
delay 500
PRINT #8,"SO1"				 
PRINTDBG "SO1"
Wait I[Code.ready_R_123]=1
Wait I[Calibcode_R_125]=6
I[Code.ready_R_123]=0
I[Calibcode_R_125]=0

*Step2:

'Step 2							Choose calibration point
Run get_reply_R
delay 500
IF I[Calpoint_R_120]=0 then
	PRINT #8,"SIM0180"				 
	PRINTDBG "SIM0180"
ELSEIF I[Calpoint_R_120]=1 then
	PRINT #8,"SIM0181"				 
	PRINTDBG "SIM0181"
ELSEIF I[Calpoint_R_120]=2 then
	PRINT #8,"SIM0182"				 
	PRINTDBG "SIM0182"
ELSEIF I[Calpoint_R_120]=3 then
	PRINT #8,"SIM0183"				 
	PRINTDBG "SIM0183"
ELSEIF I[Calpoint_R_120]=4 then
	PRINT #8,"SE2"				 
	PRINTDBG "SE2"
	Wait I[Code.ready_R_123]=1
	I[Calpoint_R_120]=0
	GOTO *step14  
ENDIF
Wait I[Code.ready_R_123]=1
Wait I[Calibcode_R_125]=6
I[Code.ready_R_123]=0
I[Calibcode_R_125]=0

'Step 3							Start camera 
Run get_reply_R
delay 500
PRINT #8,"SE1"				 
PRINTDBG "SE1"
Wait I[Code.ready_R_123]=1
Wait I[Calibcode_R_125]=6
I[Code.ready_R_123]=0
I[Calibcode_R_125]=0

*Step4:

'Step 4							Read task from cell L0 
Run Get_double_reply_R
delay 500
PRINT #8,"GVL000"				 
PRINTDBG "GVL000"
Wait I[Code.ready_R_123]=1
Wait I[Calibcode_R_125]=6
I[Code.ready_R_123]=0


'Step 5
IF I[Calposition_R_121] = 5 THEN		'If "5" NoPart
	I[Calpoint_R_120]=I[Calpoint_R_120]+1
	I[Calposition_R_121]=0
	GOTO *Step2
ELSE
	PRINTDBG "Part ready to pickup"
	I[Calibcode_R_125]=0
ENDIF

'Step 6							Acknowledge 
Run get_reply_R
delay 500
PRINT #8,"SIH0001"				 
PRINTDBG "SIH0001"
Wait I[Code.ready_R_123]=1
Wait I[Calibcode_R_125]=6
I[Code.ready_R_123]=0
I[Calibcode_R_125]=0


'Step 7
IF I[Calposition_R_121] = 0 THEN		'If 0-3 then Calib else CalibZur
	PRINTDBG "Calib 0 R"
ELSEIF I[Calposition_R_121] = 1 THEN
	PRINTDBG "Calib 1 R"
ELSEIF I[Calposition_R_121] = 2 THEN
	PRINTDBG "Calib 2 R"
ELSEIF I[Calposition_R_121] = 3 THEN
	PRINTDBG "Calib 3 R"
ELSEIF I[Calposition_R_121] = 4 THEN
	PRINTDBG "CalibZur R"
	GOTO *Step12
ENDIF

'Step 8
IF I[Cal_in_nest_R_127] = 0 THEN			'If 0 pick up from nest
	PRINTDBG "Pick up from nest"
	Changework 0
	Changetool 2
	Move p,@20 p[124],s=50
  	APPROACH  L, P[150] ,70,S= 50
  	Move L,@E P[150],s=25
  	SET IO[Set_Vacuum_L_812]
  	delay 200
	DEPART L,@1 70,S=50
	Move L,@20 p[124],s=50
	I[Cal_in_nest_R_127] = 1
ELSE 								'If 1 pick up from lastposition
	PRINTDBG "Pick up from last pos"
	Changework 1
	Changetool 2
  	APPROACH  P,P[155] ,70,S= 50
  	Move L,@E P[155],s=25
  	SET IO[Set_Vacuum_L_812]
  	delay 200
	DEPART L,@1 70,S=50
ENDIF

IF I[Calposition_R_121] = 0 THEN		'Move to 0-3 Calib position
	PRINTDBG "Move Calib 0 R"
	Changework 1
	Changetool 2
  	APPROACH  P,P[151]+(0,0,0,0,0,I[Calangel_R_122]) ,70,S= 50
  	Move L,@E P[151]+(0,0,0,0,0,I[Calangel_R_122]),s=25
  	Reset IO[Set_Vacuum_L_812]
  	delay 200

ELSEIF I[Calposition_R_121] = 1 THEN
	PRINTDBG "Move Calib 1 R"
	Changework 1
	Changetool 2
  	APPROACH  P,P[152]+(0,0,0,0,0,I[Calangel_R_122]) ,70,S= 50
  	Move L,@E P[152]+(0,0,0,0,0,I[Calangel_R_122]),s=25
  	Reset IO[Set_Vacuum_L_812]
  	delay 200

ELSEIF I[Calposition_R_121] = 2 THEN
	PRINTDBG "Move Calib 2 R"
	Changework 1
	Changetool 2
  	APPROACH  P,P[153]+(0,0,0,0,0,I[Calangel_R_122]) ,70,S= 50
  	Move L,@E P[153]+(0,0,0,0,0,I[Calangel_R_122]),s=25
  	Reset IO[Set_Vacuum_L_812]
  	delay 200

ELSEIF I[Calposition_R_121] = 3 THEN
	PRINTDBG "Move Calib 3 R"
	Changework 1
	Changetool 2
  	APPROACH  P,P[154]+(0,0,0,0,0,I[Calangel_R_122]) ,70,S= 50
  	Move L,@E P[154]+(0,0,0,0,0,I[Calangel_R_122]),s=25
  	Reset IO[Set_Vacuum_L_812]
  	delay 200

ENDIF	

P[Calib_Last_pos_R]=CURPOS

'Step 9
Run get_reply_R
delay 500
F[POS_X_R]=POSX(P[Calib_Last_pos_R])'*100
PRINT #8,"SFP000",F[POS_X_R]				 
PRINTDBG "SFP000",F[POS_X_R]
Wait I[Code.ready_R_123]=1
Wait I[Calibcode_R_125]=6
I[Code.ready_R_123]=0
I[Calibcode_R_125]=0

Run get_reply_R
delay 500
F[POS_Y_R]=POSY(P[Calib_Last_pos_R])'*100
PRINT #8,"SFQ000",F[POS_Y_R]				 
PRINTDBG "SFQ000",F[POS_Y_R]
Wait I[Code.ready_R_123]=1
Wait I[Calibcode_R_125]=6
I[Code.ready_R_123]=0
I[Calibcode_R_125]=0

'Step 10					Robot out of FOV
DEPART L,@0 70,S=50
changework 0
Changetool 2

Move P,@0 P[124],s=50

'Step 11							Acknowledge
Run get_reply_R
delay 500
PRINT #8,"SIH0000"				 
PRINTDBG "SIH0000"
Wait I[Code.ready_R_123]=1
Wait I[Calibcode_R_125]=6
I[Code.ready_R_123]=0
I[Calibcode_R_125]=0
Goto *step4 

*Step12:
'Step 12
PRINTDBG "Pick up from last pos and place in nest"
Changework 1
Changetool 2
APPROACH  P,P[155] ,70,S= 50
Move L,@E P[155],s=25
SET IO[Set_Vacuum_L_812]
delay 200
DEPART L,@1 70,S=50

Changework 0
Changetool 2
Move p,@20 p[124],s=50
APPROACH  L,P[150] ,70,S= 50
Move L,@E P[150],s=25
Reset IO[Set_Vacuum_L_812]
delay 200
DEPART L,@1 70,S=50
Move L,@0 P[124],s=50
I[Cal_in_nest_R_127] = 0

'Step 13							Acknowledge
Run get_reply_R
delay 500
PRINT #8,"SIH0000"				 
PRINTDBG "SIH0000"
Wait I[Code.ready_R_123]=1
Wait I[Calibcode_R_125]=6
I[Code.ready_R_123]=0
I[Calibcode_R_125]=0
Goto *step4 

*Step14:
Kill Get_reply_R
Kill Get_double_reply_R
RESET IO[Set_Tool_L_811]

END
